<?php

namespace Internetgalerie\IgDatapoolFe\Domain\Repository;

use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class CountryRepository extends \SJBR\StaticInfoTables\Domain\Repository\CountryRepository
{
    protected $tablename = 'static_countries';

    protected $iso2Attribute = 'cn_iso_2';
    protected $iso3Attribute = 'cn_iso_3';

    public function getIsoCountryName(string $languageTwoLetterIsoCode = '')
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable($this->tablename);

        //$queryBuilder->quoteIdentifier($languageTwoLetterIsoCode);
        $countryNameAttributes = [];
        if (!$languageTwoLetterIsoCode) {
            $siteLanguage = $GLOBALS['TYPO3_REQUEST']->getAttribute('language');
            $languageTwoLetterIsoCode = $siteLanguage->getTwoLetterIsoCode();
        }

        if (isset($GLOBALS['TCA'][$this->tablename]['columns']['cn_short_' . $languageTwoLetterIsoCode])) {
            $countryNameAttributes[] = 'cn_short_' . $languageTwoLetterIsoCode;
        }
        $countryNameAttributes[] = 'cn_short_en';
        $countryNameAttributes[] = 'cn_official_name_local';

        $result = $queryBuilder
                ->selectLiteral('uid,' . $this->iso2Attribute . ' AS iso2,' . $this->iso3Attribute . ' AS iso3, COALESCE(' . implode(',', $countryNameAttributes) . ') AS name')
                ->from($this->tablename)
                ->orderBy('name')
                ->execute();
        return $result->fetchAll();
    }
}
