<?php

namespace Internetgalerie\IgDatapoolFe\Services;

//implements \TYPO3\CMS\Core\SingletonInterface {
use TYPO3\CMS\Core\Imaging\Icon;
use TYPO3\CMS\Core\Imaging\IconFactory;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Utility\VersionNumberUtility;

class IconService
{
    /**
     * Initialize the arguments.
     *
     * @param string $identifier
     *
     * @return string
     **/
    public static function getIcon($identifier, $class='', $style='')
    {
        if (VersionNumberUtility::convertVersionNumberToInteger(TYPO3_version) < 7000000) {
            $combatIcons = [
              'actions-edit-delete' => 'group_clear.gif',
              'actions-move-down' => 'down.gif',
              'actions-move-up' => 'up.gif',
              ];
            $img= isset($combatIcons[$identifier]) ? $combatIcons[$identifier] : 'helpmark.gif';
            return '<div class="dp-sprite'.($class ? ' '.$class : '').'"'.($style ? ' style="'.$style.'"' : '').'><img src="/typo3/sysext/t3skin/icons/gfx/'.$img.'" alt="'.$identifier.'" title="'.$identifier.'" /></div>';
        } else {
            $iconFactory = GeneralUtility::makeInstance(IconFactory::class);
            return '<div class="dp-sprite'.($class ? ' '.$class : '').'"'.($style ? ' style="'.$style.'"' : '').'>'. $iconFactory->getIcon($identifier, Icon::SIZE_SMALL)->render('inline').'</div>';
        }
    }
}
