<?php

namespace Internetgalerie\IgDatapoolFe\ViewHelpers\Form;

/**
 * View Helper which creates a simple checkbox (<input type="checkbox">).
 *
 * = Examples =
 *
 * <code title="Example">
 * <f:form.checkbox name="myCheckBox" value="someValue" />
 * </code>
 * <output>
 * <input type="checkbox" name="myCheckBox" value="someValue" />
 * </output>
 *
 * <code title="Preselect">
 * <f:form.checkbox name="myCheckBox" value="someValue" checked="{object.value} == 5" />
 * </code>
 * <output>
 * <input type="checkbox" name="myCheckBox" value="someValue" checked="checked" />
 * (depending on $object)
 * </output>
 *
 * <code title="Bind to object property">
 * <f:form.checkbox property="interests" value="TYPO3" />
 * </code>
 * <output>
 * <input type="checkbox" name="user[interests][]" value="TYPO3" checked="checked" />
 * (depending on property "interests")
 * </output>
 *
 * @author     Markus Baumgartner <mb@stylesheep.ch>, Internetgalerie AG
 * @package    IgDatapoolFE
 * @subpackage ViewHelpers
 * @api
 */
//class CheckboxViewHelper extends RadioViewHelper implements FieldInterface
class CheckboxViewHelper extends \Internetgalerie\IgCoreViewhelpers\ViewHelpers\Form\CheckboxViewHelper implements FieldInterface
{
    use FormFieldTrait;
    /*    protected function generateId($arguments) {

        $fieldId= $fieldId = 'dp-field-' . str_replace('.', '-',strtolower( $arguments['property']));
        $fieldId.= '-' . $arguments['value'];
        return $fieldId;

    }
    */        /*
      protected $type = 'checkbox';

    public function initializeArguments() {
      parent::initializeArguments();
      if (version_compare(TYPO3_version, '7.6.99', '<=')) {
        $this->registerArgument('checked', 'boolean', 'Target action');
      }
    }
    */
    /**
     * Renders the checkbox.
     *
     * @throws \TYPO3Fluid\Fluid\Core\ViewHelper\Exception
     * @return string
     * @api
     */
    /*
    public function render() {
        $res = $this -> renderHiddenFieldForEmptyValue();
        $res .= parent::render($this->arguments['checked']);
        return $res;
    }
    */
}
